<?php
# Kommentar-Funktion (C) 2002 by Alex (http://alex.ilosuna.org/)
# Dieses Script darf verndert und weitergegeben werden.
# Das Script besteht aus einer PHP-Funktion (function kommentar($was)). Diese
# kann entweder direkt in die jeweilige PHP-Seite oder per <?php
# include("kommentar.php"); ?>  eingefgt werden. An der Stelle, an der die
# Kommentare und das Formular zum Eintragen der Kommentare erscheinen soll,
# muss lediglich <?php kommentar("name_der_Seite"); ?> stehen. Mit
# unterschiedlichen Namen aufgerufen, kann die Funktion von verschiedenen
# Seiten oder auch von einer Seite aus mehrmals aufgerufen werden.
# Die Kommentare knnen entweder oben oder unten angehngt werden. Es kann
# festgelegt werden, wieviele Kommentare angezeigt werden sollen. Wenn mehr
# vorhanden sind, werden die neuesten angezeigt und es erscheint ein Link um
# alle anzuzeigen.
# Die Kommentare werden unter dem jeweiligen Namen (hier z.B. "name_der_Seite")
# in der Datei kommentare.dat gespeichert. Diese Datei bentigt Schreiberechte
# (CHMOD 666). Zu Beginn einfach eine leere Datei unter "kommentare.dat"
# abspeichern, raufladen und auf CHMOD 666 stellen.

 function kommentar($was)
 {
  # Einstellungen:
  # neue Kommentare oben oder unten anhngen?
  $neue_kommentare = "unten";

  # wieviele Kommentare sollen maximal angezeigt werden (falls mehr Kommentare
  # vorhanden sind, erschein ein Link um alle anzuzeigen)?
  $maximal = 10;

  # Was angezeigt werden soll, falls kein Name eingegeben wurde:
  $anonym = "Anonym";

  # nach wievielen Zeichen sollen (lange) Wrter geteilt werden (damit das
  # Layout nicht "gesprengt" wird? Hierfr wird die Funktion "nolongwords()"
  # (siehe unten) bentigt. Auskommentieren oder gleich null setzen, falls
  # diese Funktion nicht benutzt werden soll.
  $woerter_teilen = "40";

  # in dieser Datei werden die Kommentare gespeichert (diese Datei auf
  # CHMOD 666 setzen)
  $kommentardatei = "kommentare.dat";
  # Ende der Einstellungen


  if (isset($_GET['kommentare'])) $kommentare = $_GET['kommentare'];
  if (isset($_POST['was'])) $w_was = $_POST['was'];
  if (isset($_POST['name'])) $name = $_POST['name'];
  if (isset($_POST['kommentartext'])) $kommentartext = $_POST['kommentartext'];
  if (isset($kommentartext) && $kommentartext != "" && $was==$w_was)
   {
    $datum=date("d.m.Y|H:i");

    if ($neue_kommentare == "oben")
    {
     $data = file($kommentardatei);
     $c = count($data);
     $datei = fopen($kommentardatei, 'w+');
     flock($datei, 2);
     fwrite($datei, $datum . "|" . $_SERVER["REMOTE_ADDR"] . "|" . $name . "|e|h|" . $w_was . "|" . urlencode($kommentartext) . "\n");
     for ($i = 0; $i < $c; $i++) { fwrite($datei, $data[$i]); }
     flock($datei, 3);
     fclose($datei);
    }
    else
    {
     $datei = fopen($kommentardatei, "a");
     flock($datei, 2);
     fwrite($datei, $datum . "|" . $_SERVER["REMOTE_ADDR"] . "|" . $name . "|e|h|" . $w_was . "|" . urlencode($kommentartext) . "\n");
     flock($datei, 3);
     fclose($datei);
    }

   }
  $data = file($kommentardatei);
  $entry_count = count($data);
  echo "<p><ul>";

  // zhlen, wieviele Eintrge es zu "$was" gibt:
  $wieviele = 0;
  for ($i = 0; $i < $entry_count; $i++)
  {
   $parts = explode("|", $data[$i]);
   if ($parts[6] == $was) { $wieviele++; }
  }

  $k = 0;
  for ($i = 0; $i < $entry_count; $i++)
    {
     $parts = explode("|", $data[$i]);
     if ($parts[6] == $was)
      {
       $k++;
       if ($parts[3] != "") { $name = str_replace("&lt;br&gt;", " - ", trim(htmlentities(stripslashes(urldecode($parts[3]))))); } else $name = $anonym;
       $kommentar = str_replace("&lt;br&gt;", " - ", trim(htmlentities(stripslashes(urldecode($parts[7])))));
       $datum = $parts[0];
       $zeit = $parts[1];

       if (isset($woerter_teilen) && $woerter_teilen > 0) { $kommentar = nolongwords($kommentar,$woerter_teilen); }

       if ($neue_kommentare == "oben")
        {
         if (isset($kommentare) or ($k<=$maximal)) echo "<li style=\"margin: 5px;\"><b>" . $name . ":</b>&nbsp;" . $kommentar . "<br><span style=\"font-size: 10px; color: #808080;\">(" . $datum . ", " . $zeit . " Uhr)</span></li>";
        }
       else
        {
         if (isset($kommentare) or $k > ($wieviele-$maximal)) echo "<li style=\"margin: 5px;\"><b>" . $name . ":</b>&nbsp;" . $kommentar . "<br><span style=\"font-size: 10px; color: #808080;\">(" . $datum . ", " . $zeit . " Uhr)</span></li>";
        }
      }
    }

 if ($k == 0) echo "<li>noch keine Kommentare</li>";
 echo "</ul></p>";
 if (isset($maximal) && $maximal < $wieviele && empty($kommentare)) { ?><p class="klein">Es werden <?php echo $maximal; ?> von <?php echo $wieviele; ?> Kommentaren angezeigt. --> <a href="<?php echo $_SERVER["PHP_SELF"]; ?>?kommentare=alle#Kommentare">alle anzeigen...</a></p><?php }
 ?>
 <p><br><b>Kommentar schreiben:</b><br>
 <form method="post" action="<?php echo $_SERVER["PHP_SELF"]; ?>">
 <input type="hidden" name="was" value="<?php echo $was; ?>">
 <textarea name="kommentartext" cols="45" rows="3"></textarea><br>
 <span class="klein">Name: </span><input type="text" name="name" size="23" maxlength="30">&nbsp;<input class="klein" type="submit" value="  OK  ">
 </form></p>
 <?php
 }

function nolongwords($text,$maxlaenge) {
   $text_arr = explode(" ",$text);
   $text="";
   for ($i=0;$i<count($text_arr);$i++){
       $text_arr[$i].=" ";
       $laenge = strlen($text_arr[$i]);
       if($laenge>=$maxlaenge){
           $word1 = substr($text_arr[$i],0,$maxlaenge);
           $rest = substr($text_arr[$i],$maxlaenge,$laenge);
           $zaehler = $laenge / $maxlaenge;
           $zaehler = round($zaehler)+1;
           $words = "";
           for($z=1;$z<$zaehler;$z++) {
              $getword = substr($rest,0,$maxlaenge);
              $words.= $getword." ";
              $rest = substr($rest,$maxlaenge,$laenge);
           }
           $text.= $word1." ".$words;
       }
       else
           $text.=$text_arr[$i];
   }
   $text=trim($text);
   return $text;
 }